Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography Library 1.84
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.bouncycastle.crypto
Interface Xof

All Superinterfaces:
  Digest, ExtendedDigest

All Known Implementing Classes:
  AsconXof, org.bouncycastle.crypto.digests.AsconXofBase, Blake2xsDigest, Blake3Digest, org.bouncycastle.crypto.digests.Kangaroo.KangarooBase, KMAC, ParallelHash, SHAKEDigest, TupleHash

public interface Xof
extends ExtendedDigest

With FIPS PUB 202 a new kind of message digest was announced which supported extendable output, or variable digest sizes. This interface provides the extra method required to support variable output on an extended digest implementation.

Method Summary
`int` | `doFinal(byte[] out, int outOff, int outLen)` Output the results of the final calculation for this digest to outLen number of bytes.
`int` | `doOutput(byte[] out, int outOff, int outLen)` Start outputting the results of the final calculation for this digest.

Methods inherited from interface org.bouncycastle.crypto.ExtendedDigest
`getByteLength`

Methods inherited from interface org.bouncycastle.crypto.Digest
`doFinal, getAlgorithmName, getDigestSize, reset, update, update`

Method Detail

### doFinal

    public int doFinal(byte[] out,
                       int outOff,
                       int outLen)

  Output the results of the final calculation for this digest to outLen number of bytes.

  Parameters:
    `out` - output array to write the output bytes to.
    `outOff` - offset to start writing the bytes at.
    `outLen` - the number of output bytes requested.
  Returns:
    the number of bytes written

### doOutput

    public int doOutput(byte[] out,
                        int outOff,
                        int outLen)

  Start outputting the results of the final calculation for this digest. Unlike doFinal, this method will continue producing output until the Xof is explicitly reset, or signals otherwise.

  Parameters:
    `out` - output array to write the output bytes to.
    `outOff` - offset to start writing the bytes at.
    `outLen` - the number of output bytes requested.
  Returns:
    the number of bytes written

Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography Library 1.84
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD